/*!
    * FastSpring fsmodal.js
*/
function fsaddProd(prod) {
fastspring.builder.add(prod, function(data){
        openCart();
    });
}

function applycoupon() {
    var couponid= document.getElementById('couponcode').value;
    fastspring.builder.promo(couponid);
}

function markupHelpersCallback() {
    Handlebars.registerHelper('iff', function(lvalue, operator, rvalue, options) {
        //if (window.hasOwnProperty(rvalue)) rvalue = window[rvalue];
        var functions = {
            '==':       function(l,r) { return l == r; },
            '===':      function(l,r) { return l === r; },
            '!=':       function(l,r) { return l != r; },
            '<':        function(l,r) { return l < r; },
            '>':        function(l,r) { return l > r; },
            '<=':       function(l,r) { return l <= r; },
            '>=':       function(l,r) { return l >= r; },
            'typeof':   function(l,r) { return typeof l === r; }
        };
        if (!functions.hasOwnProperty(operator)){
            throw new Error("Handlerbars Helper 'iff' doesn't know the operator " + operator);
        }
        var result = functions[operator](lvalue,rvalue);
        if( result ) {
            return options.fn(this);
        } else {
            return options.inverse(this);
        }
    });
    Handlebars.registerPartial("pricing", document.getElementById('pricing-partial').innerHTML);
    Handlebars.registerPartial("quantity", document.getElementById('quantity-partial').innerHTML);
    Handlebars.registerPartial("volume-discount", document.getElementById('volume-discount').innerHTML);
    Handlebars.registerPartial("xsellupsell", document.getElementById('xsellupsell').innerHTML);
    Handlebars.registerPartial("singlechoice", document.getElementById('singlechoice').innerHTML);
    Handlebars.registerPartial("multichoice", document.getElementById('multichoice').innerHTML);
}

function beforeRequestsCallbackFunction() {
    var fs_spinner=document.getElementById("fs_spinner");
    fs_spinner.style.display = "block";
}

function afterMarkupCallbackFunction() {
    var fs_spinner=document.getElementById("fs_spinner");
    fs_spinner.style.animationName="fs_revfadeIn";
    setTimeout(function(){
        fs_spinner.style.animationName = "fs_fadeIn";
        fs_spinner.style.display = "none";
    },450);
}

function popupClosed(data) {
    var fs_spinner=document.getElementById("fs_spinner");
    fs_spinner.style.animationName="fs_revfadeIn";
    setTimeout(function(){
        fs_spinner.style.animationName = "fs_fadeIn";
        fs_spinner.style.display = "none";
    },450);
    if (data) {
        fastspring.builder.reset();
        /*If you want to redirect you can do the following*/
        /*window.location.replace("https://myDomain.com/?orderId=" + data.reference);*/
    } else {
        openCart();
    }
}

/*If using Google Analytics, you can use the following function to decorate the links*/
function decorateCallback(url) {
    var linkerParam = null;
    if ( ga && typeof ga === 'function') {
        ga(function() {
            var trackers = ga.getAll();
            linkerParam = trackers[0].get('linkerParam');
        });
    }
    return (linkerParam ? url + '?' + linkerParam : url);
}

function errorCallback(code, string) {
    console.log('errorcallback');
    var fs_spinner=document.getElementById("fs_spinner");
    fs_spinner.style.animationName="fs_revfadeIn";
    setTimeout(function(){
        fs_spinner.style.animationName = "fs_fadeIn";
        fs_spinner.style.display = "none";
    },450);
    var fs_modal = document.getElementById('fs_modal');
    if(fs_modal.style.display === 'block') {
        var fs_mod_error=document.getElementById("fs_mod_error");
        var fs_mod_error_msg=document.getElementById("fs_mod_error_msg");
        fs_mod_error.style.display = "block";
        fs_mod_error.style.animationName = "fs_mod_animatetop";
        fs_mod_error_msg.innerHTML = "Error: " + code + " - " + string;
        setTimeout(function(){
            fs_mod_error.style.animationName = "fs_mod_revanimatetop";
            setTimeout(function(){
                fs_mod_error.style.display = "none";
            }, 400)
        },5000);
    } else {
        var fs_error=document.getElementById("fs_error");
        var fs_error_msg=document.getElementById("fs_error_msg");
        fs_error.style.display = "block";
        fs_error.style.animationName = "fs_mod_animatetop";
        fs_error_msg.innerHTML = "Error: " + code + " - " + string;
        setTimeout(function(){
            fs_error.style.animationName = "fs_mod_revanimatetop";
            setTimeout(function(){
                fs_error.style.display = "none";
            }, 400)
        },5000);
    }
}

function dataCallback(data) {
    if(data.messages[0]) {
        var fs_modal = document.getElementById('fs_modal');
        if(fs_modal.style.display === 'block') {
            var fs_mod_error=document.getElementById("fs_mod_error");
            var fs_mod_error_msg=document.getElementById("fs_mod_error_msg");
            fs_mod_error.style.display = "block";
            fs_mod_error.style.animationName = "fs_mod_animatetop";
            fs_mod_error_msg.innerHTML = data.messages[0].phrase;
            setTimeout(function(){
                fs_mod_error.style.animationName = "fs_mod_revanimatetop";
                setTimeout(function(){
                    fs_mod_error.style.display = "none";
                }, 400)
            },5000);
        } else {
            var fs_error=document.getElementById("fs_error");
            var fs_error_msg=document.getElementById("fs_error_msg");
            fs_error.style.display = "block";
            fs_error.style.animationName = "fs_mod_animatetop";
            fs_error_msg.innerHTML = data.messages[0].phrase;
            setTimeout(function(){
                fs_error.style.animationName = "fs_mod_revanimatetop";
                setTimeout(function(){
                    fs_error.style.display = "none";
                }, 400)
            },5000);
        }
    }
}

var fs_modal = document.getElementById('fs_modal');
var fs_bs_modalcontent = document.getElementById('fs_bs_modal-content');
var fs_ls_modalcontent = document.getElementById('fs_ls_modal-content');
var fs_rs_modalcontent = document.getElementById('fs_rs_modal-content');
var fs_mod_modalcontent = document.getElementById('fs_mod_modal-content');

function openCart() {
        fs_modal.style.display = "block";
        document.body.classList.add("modalOpen");
}

function BS_Close() {
            document.body.classList.remove("modalOpen");
            fs_bs_modalcontent.style.animationName = "fs_bs_revslideIn";
            fs_modal.style.animationName="fs_revfadeIn";
            setTimeout(function(){
                fs_modal.style.display = "none";
                fs_bs_modalcontent.style.animationName = "fs_bs_slideIn";
                fs_modal.style.animationName="fs_fadeIn";
            },350);
}

function LS_Close() {
            document.body.classList.remove("modalOpen");
            fs_ls_modalcontent.style.animationName = "fs_ls_revslideIn";
            fs_modal.style.animationName="fs_revfadeIn";
            setTimeout(function(){
                fs_modal.style.display = "none";
                fs_ls_modalcontent.style.animationName = "fs_ls_slideIn";
                fs_modal.style.animationName="fs_fadeIn";
            },350);
}

function RS_Close() {
            document.body.classList.remove("modalOpen");
            fs_rs_modalcontent.style.animationName = "fs_rs_revslideIn";
            fs_modal.style.animationName="fs_revfadeIn";
            setTimeout(function(){
                fs_modal.style.display = "none";
                fs_rs_modalcontent.style.animationName = "fs_rs_slideIn";
                fs_modal.style.animationName="fs_fadeIn";
            },350);
}

function MOD_Close() {
    document.body.classList.remove("modalOpen");
    fs_mod_modalcontent.style.animationName = "fs_mod_revanimatetop";
    fs_modal.style.animationName="fs_revfadeIn";
    setTimeout(function(){
        fs_modal.style.display = "none";
        fs_mod_modalcontent.style.animationName = "fs_mod_animatetop";
        fs_modal.style.animationName="fs_fadeIn";
    },350);
}

window.onclick = function(event) {
    if (event.target == fs_modal) {
        document.body.classList.remove("modalOpen");
            if (fs_modal.classList.contains('fs_BS')) {
                    fs_bs_modalcontent.style.animationName = "fs_bs_revslideIn";
                    fs_modal.style.animationName="fs_revfadeIn";
                    setTimeout(function(){
                        fs_modal.style.display = "none";
                        fs_bs_modalcontent.style.animationName = "fs_bs_slideIn";
                        fs_modal.style.animationName="fs_fadeIn";
                    },350);
            }

            if (fs_modal.classList.contains('fs_LS')) {
                    fs_ls_modalcontent.style.animationName = "fs_ls_revslideIn";
                    fs_modal.style.animationName="fs_revfadeIn";
                    setTimeout(function(){
                        fs_modal.style.display = "none";
                        fs_ls_modalcontent.style.animationName = "fs_ls_slideIn";
                        fs_modal.style.animationName="fs_fadeIn";
                    },350);
            }

            if (fs_modal.classList.contains('fs_RS')) {
                    fs_rs_modalcontent.style.animationName = "fs_rs_revslideIn";
                    fs_modal.style.animationName="fs_revfadeIn";
                    setTimeout(function(){
                        fs_modal.style.display = "none";
                        fs_rs_modalcontent.style.animationName = "fs_rs_slideIn";
                        fs_modal.style.animationName="fs_fadeIn";
                    },350);
            }
            if (fs_modal.classList.contains('fs_MOD')) {
                    fs_mod_modalcontent.style.animationName = "fs_mod_revanimatetop";
                        fs_modal.style.animationName="fs_revfadeIn";
                        setTimeout(function(){
                            fs_modal.style.display = "none";
                            fs_mod_modalcontent.style.animationName = "fs_mod_animatetop";
                            fs_modal.style.animationName="fs_fadeIn";
                        },350);
            }
    }
}